<template>
  <div class="container">
    <section class="section">
      <div class="columns">
        <div class="column">
          <b-field label="AllowList site checker">
            <textarea class="textarea" placeholder="list of URLs, one line is one URL to check" v-model="listText"></textarea>
          </b-field>
        </div>
      </div>
      <div class="buttons">
        <b-dropdown v-model="category" aria-role="list" class="mr-3">

          <template v-if="category" #trigger>
            <b-button
              v-bind:label="category.label"
              icon-right="menu-down" />
          </template>

          <template v-else #trigger>
            <b-button
              label="Allow list"
              icon-right="menu-down" />
          </template>

          <b-dropdown-item v-for="item in categories" v-bind:value="item" v-bind:key="item.id" aria-role="listitem">
            <div class="media">
              <b-icon class="media-left" icon="format-list-bulleted"></b-icon>
              <div class="media-content">
                <p style="margin-top: 0.15em;">{{item.label}}</p>
              </div>
            </div>
          </b-dropdown-item>

        </b-dropdown>

        <button class="button is-link" v-on:click="runTests">Run test</button>

        <button v-on:click="test">test</button>
      </div>
    </section>
    <section class="section p-0 pt-4">

      <div class="columns box p-2" v-for="item in this.results">
        <div class="column is-three-quarters">
          {{item.url}}
        </div>
        <div class="column has-text-right">
          <span v-bind:class="{
            'has-text-success': item.status === 'success',
            'has-text-danger': item.status.indexOf('error') > -1
          }">{{item.status}}</span>
        </div>
      </div>

    </section>
  </div>
</template>

<script>
import urls from '../urls.json'
import testUrl from '~/helpers/testUrl';

export default {
  name: 'IndexPage',
  data() {
    return {
      listText: '',
      allUrls: [],
      categories: [],
      category: null,
      results: []
    }
  },
  mounted() {
    this.categories = urls.categories;
    this.allUrls = urls.list;
  },
  methods: {
    parseList() {
      const list = this.listText ? this.listText.split('\n') : [];
      console.log('parseList', this.listText, list);
      this.results = list.map(item => item.trim()).map(item => Object.assign({}, {
        url:item,
        status: 'testing...'
      }))
    },
    runTests() {
      this.parseList();
      for (let i in this.results) {
        if (!this.results.hasOwnProperty(i)) {
          continue;
        }
        try {
          this.testUrl(this.results[i].url)
            .then((result) => {
              this.results[i].status = result
            })
            .catch((error) => {
              this.results[i].status = error
            });
        } catch (e) {
          console.error('catch', e);
          this.results[i].status = 'blocked'
        }
      }
    },
    testUrl(url) {
      return testUrl(url);
    },
    filterByCategory(id) {
      return this.allUrls.filter(item => item.category.includes(id));
    },
    test() {
      const element = document.createElement('img');
      element.src = 'https://yaizy.io';
      element.onerror = () => {
        console.error('error 1')
      }
      element.onabort= () => {
        console.error('error 2')
      }
      document.body.appendChild(element);
    }
  },
  watch: {
    category(val) {
      this.results = [];
      if (val) {
        this.listText = this.filterByCategory(val.id).map(item => item.url).join('\n');
      } else {
        this.listText = '';
      }
    }
  }
}
</script>
